// Hoe stuur je MIDI CC?
// Midi Channels
int FSRMidi = 176;
int EncMidi = 177;
int EncBMidi = 178;
int SonarMidi = 179;
int MoistureMidi = 180;
int PotMidi = 181;
// Kan je checken of deze al in gebruik zijn?

//// Rotary stuff
// Rotary turn pins
#define ENC_A 2
#define ENC_B 3

#define ENC_C 4
#define ENC_D 5

#define ENC_E 6
#define ENC_F 7

#define ENC_G 8
#define ENC_H 9

//Rotary button pins
#define EP_A 22
#define EP_B 21
#define EP_C 20
#define EP_D 19

// Keeps track of time between rotations
unsigned long _lastIncReadTime1 = micros();
unsigned long _lastDecReadTime1 = micros();
unsigned long _lastIncReadTime2 = micros();
unsigned long _lastDecReadTime2 = micros();
unsigned long _lastIncReadTime3 = micros();
unsigned long _lastDecReadTime3 = micros();
unsigned long _lastIncReadTime4 = micros();
unsigned long _lastDecReadTime4 = micros();

// How fast is turning fast?
int _pauseLength = 25000;
// Defines how much the encoder jumps up if you turn fast
int _fastIncrement = 10;

// Keeps track of rotary position
volatile int counter1 = 0;
volatile int counter2 = 0;
volatile int counter3 = 0;
volatile int counter4 = 0;

// Keep track of which buttons are pressed
int but1;
int but2;
int but3;
int but4;
int encB1;
int encB2;
int encB3;
int encB4;

//// Sonar pins
#include <HCSR04.h>
UltraSonicDistanceSensor distanceSensor1(29, 30);
UltraSonicDistanceSensor distanceSensor2(41, 38);
int SI1;
int SI2;

//// FSR pins
#define FSRPin1 A15
#define FSRPin2 A14
int FSR1;
int FSR2;

//// Moisture pin
int moisturePin = 10;
int sensorValue;

//// Potmeter pins
#define POTPin1 A13
#define POTPin2 A12
unsigned int IP1;
unsigned int IP2;

////
bool errorCheck = false;

void setup() {
  setup_encoders();
  //check();
  Serial.begin(115200);


  Serial.println("dog");
}

void ErrorCheckingStart() {
}
void ErrorCheckingLoop() {
}

void loop() {
  read();
  midiOut();
  while (usbMIDI.read())
    ;  // read and discard any incoming MIDI messages
  delay(25);
}

// Send MIDI messages
void midiOut() {
  //// ???????????????????
  // Send FSR
  usbMIDI.sendControlChange(FSRMidi, FSR1, 1);
  usbMIDI.sendControlChange(FSRMidi, FSR2, 2);

  // Send Encoders
  usbMIDI.sendControlChange(EncMidi, counter1, 1);
  usbMIDI.sendControlChange(EncMidi, counter2, 2);
  usbMIDI.sendControlChange(EncMidi, counter3, 3);
  usbMIDI.sendControlChange(EncMidi, counter4, 4);

  // Send Encoder buttons
  usbMIDI.sendControlChange(EncBMidi, encB1, 1);
  usbMIDI.sendControlChange(EncBMidi, encB2, 2);
  usbMIDI.sendControlChange(EncBMidi, encB3, 3);
  usbMIDI.sendControlChange(EncBMidi, encB4, 4);

  // Send Moisture
  usbMIDI.sendControlChange(MoistureMidi, sensorValue, 1);

  // Send Sonar's
  usbMIDI.sendControlChange(SonarMidi, SI1, 1);
  usbMIDI.sendControlChange(SonarMidi, SI2, 2);

  // Send Potmeters
  //usbMIDI.sendControlChange(PotMidi, IP1, 1);
  //usbMIDI.sendControlChange(PotMidi, IP2, 2);
}
// Reads every sensor
void read() {
  //Read encoders
  print_encoders();
  print_buttons();

  // Read sonars
  print_sonars();

  // Read moisture sensor
  sensorValue = analogRead(moisturePin);  // Pin24
  sensorValue = map(sensorValue, 0, 1023, 127, 0);
  //Serial.println(sensorValue);

  // Read FSR's
  FSR1 = map(analogRead(FSRPin1), 0, 850, 0, 127);
  if (FSR1 > 127) { FSR1 = 127; }
  FSR2 = map(analogRead(FSRPin2), 0, 850, 0, 127);
  if (FSR2 > 127) { FSR2 = 127; }
  //Serial.println(FSR1);
  //Serial.println(FSR2);


  // Read potmeters
  IP1 = map(analogRead(POTPin1), 0, 1023, 0, 127);
  IP2 = map(analogRead(POTPin2), 0, 1023, 0, 127);
}

void print_sonars() {
  SI1 = distanceSensor1.measureDistanceCm() * 100;
  if (SI1 < 0) {SI1 = 0;}
  else {
    SI1 = map(SI1, 2000, 250, 0, 127);
    SI1 = constrain(SI1, 0, 127);
    if (SI1 == 148) { SI1 = 0; }
    Serial.println(SI1);
  }

  SI2 = distanceSensor2.measureDistanceCm() * 100;
  if (SI2 < 0) {SI2 = 0;}
  else {
    SI2 = map(SI2, 2000, 250, 0, 127);
    SI2 = constrain(SI2, 0, 127);
    if (SI2 == 148) { SI2 = 0; }
    Serial.println(SI2);
  }
}

void setup_encoders() {
  // Set encoder pins and attach interrupts
  pinMode(ENC_A, INPUT_PULLUP);
  pinMode(ENC_B, INPUT_PULLUP);
  pinMode(ENC_C, INPUT_PULLUP);
  pinMode(ENC_D, INPUT_PULLUP);
  pinMode(ENC_E, INPUT_PULLUP);
  pinMode(ENC_F, INPUT_PULLUP);
  pinMode(ENC_G, INPUT_PULLUP);
  pinMode(ENC_H, INPUT_PULLUP);
  attachInterrupt(digitalPinToInterrupt(ENC_A), read_encoder1, CHANGE);
  attachInterrupt(digitalPinToInterrupt(ENC_B), read_encoder1, CHANGE);
  attachInterrupt(digitalPinToInterrupt(ENC_C), read_encoder2, CHANGE);
  attachInterrupt(digitalPinToInterrupt(ENC_D), read_encoder2, CHANGE);
  attachInterrupt(digitalPinToInterrupt(ENC_E), read_encoder3, CHANGE);
  attachInterrupt(digitalPinToInterrupt(ENC_F), read_encoder3, CHANGE);
  attachInterrupt(digitalPinToInterrupt(ENC_G), read_encoder4, CHANGE);
  attachInterrupt(digitalPinToInterrupt(ENC_H), read_encoder4, CHANGE);

  // Set encoder push buttons
  pinMode(EP_A, INPUT_PULLUP);
  pinMode(EP_B, INPUT_PULLUP);
  pinMode(EP_C, INPUT_PULLUP);
  pinMode(EP_D, INPUT_PULLUP);
}

void print_buttons() {
  but1 = digitalRead(EP_A);
  if (but1 == LOW) {
    encB1 = 127;
  } else {
    encB1 = 0;
  }
  but2 = digitalRead(EP_B);
  if (but2 == LOW) {
    encB2 = 127;
  } else {
    encB2 = 0;
  }
  but3 = digitalRead(EP_C);
  if (but3 == LOW) {
    encB3 = 127;
  } else {
    encB3 = 0;
  }
  but4 = digitalRead(EP_D);
  if (but4 == LOW) {
    encB4 = 127;
  } else {
    encB4 = 0;
  }
}

void print_encoders() {
  static int lastCounter1 = 0;
  static int lastCounter2 = 0;
  static int lastCounter3 = 0;
  static int lastCounter4 = 0;

  // If count has changed print the new value to serial
  if (counter1 != lastCounter1) {
    Serial.print("C1 = ");
    Serial.println(counter1);
    lastCounter1 = counter1;
  }
  if (counter2 != lastCounter2) {
    Serial.print("C2 = ");
    Serial.println(counter2);
    lastCounter2 = counter2;
  }
  if (counter3 != lastCounter3) {
    Serial.print("C3 = ");
    Serial.println(counter3);
    lastCounter3 = counter3;
  }
  if (counter4 != lastCounter4) {
    Serial.print("C4 = ");
    Serial.println(counter4);
    lastCounter4 = counter4;
  }
}
// Should probably just write a function for this
void read_encoder1() {
  // Encoder interrupt routine for both pins. Updates counter
  // if they are valid and have rotated a full indent

  static uint8_t old_AB = 3;                                                                  // Lookup table index
  static int8_t encval = 0;                                                                   // Encoder value
  static const int8_t enc_states[] = { 0, -1, 1, 0, 1, 0, 0, -1, -1, 0, 0, 1, 0, 1, -1, 0 };  // Lookup table

  old_AB <<= 2;  // Remember previous state

  if (digitalRead(ENC_A)) old_AB |= 0x02;  // Add current state of pin A
  if (digitalRead(ENC_B)) old_AB |= 0x01;  // Add current state of pin B

  encval += enc_states[(old_AB & 0x0f)];

  // Update counter if encoder has rotated a full indent, that is at least 4 steps
  if (encval > 3) {  // Four steps forward
    int changevalue = 1;
    if ((micros() - _lastIncReadTime1) < _pauseLength) {
      changevalue = _fastIncrement * changevalue;
    }
    _lastIncReadTime1 = micros();
    counter1 = counter1 + changevalue;  // Update counter
    encval = 0;
  } else if (encval < -3) {  // Four steps backward
    int changevalue = -1;
    if ((micros() - _lastDecReadTime1) < _pauseLength) {
      changevalue = _fastIncrement * changevalue;
    }
    _lastDecReadTime1 = micros();
    counter1 = counter1 + changevalue;  // Update counter
    encval = 0;
  }
  if (counter1 > 127) {
    counter1 = 127;
  }
  if (counter1 < 0) {
    counter1 = 0;
  }
}
void read_encoder2() {
  // Encoder interrupt routine for both pins. Updates counter
  // if they are valid and have rotated a full indent

  static uint8_t old_AB = 3;                                                                  // Lookup table index
  static int8_t encval = 0;                                                                   // Encoder value
  static const int8_t enc_states[] = { 0, -1, 1, 0, 1, 0, 0, -1, -1, 0, 0, 1, 0, 1, -1, 0 };  // Lookup table

  old_AB <<= 2;  // Remember previous state

  if (digitalRead(ENC_C)) old_AB |= 0x02;  // Add current state of pin A
  if (digitalRead(ENC_D)) old_AB |= 0x01;  // Add current state of pin B

  encval += enc_states[(old_AB & 0x0f)];

  // Update counter if encoder has rotated a full indent, that is at least 4 steps
  if (encval > 3) {  // Four steps forward
    int changevalue = 1;
    if ((micros() - _lastIncReadTime2) < _pauseLength) {
      changevalue = _fastIncrement * changevalue;
    }
    _lastIncReadTime2 = micros();
    counter2 = counter2 + changevalue;  // Update counter
    encval = 0;
  } else if (encval < -3) {  // Four steps backward
    int changevalue = -1;
    if ((micros() - _lastDecReadTime2) < _pauseLength) {
      changevalue = _fastIncrement * changevalue;
    }
    _lastDecReadTime2 = micros();
    counter2 = counter2 + changevalue;  // Update counter
    encval = 0;
  }
  if (counter2 > 127) {
    counter1 = 127;
  }
  if (counter2 < 0) {
    counter1 = 0;
  }
}
void read_encoder3() {
  // Encoder interrupt routine for both pins. Updates counter
  // if they are valid and have rotated a full indent

  static uint8_t old_AB = 3;                                                                  // Lookup table index
  static int8_t encval = 0;                                                                   // Encoder value
  static const int8_t enc_states[] = { 0, -1, 1, 0, 1, 0, 0, -1, -1, 0, 0, 1, 0, 1, -1, 0 };  // Lookup table

  old_AB <<= 2;  // Remember previous state

  if (digitalRead(ENC_E)) old_AB |= 0x02;  // Add current state of pin A
  if (digitalRead(ENC_F)) old_AB |= 0x01;  // Add current state of pin B

  encval += enc_states[(old_AB & 0x0f)];

  // Update counter if encoder has rotated a full indent, that is at least 4 steps
  if (encval > 3) {  // Four steps forward
    int changevalue = 1;
    if ((micros() - _lastIncReadTime3) < _pauseLength) {
      changevalue = _fastIncrement * changevalue;
    }
    _lastIncReadTime3 = micros();
    counter3 = counter3 + changevalue;  // Update counter
    encval = 0;
  } else if (encval < -3) {  // Four steps backward
    int changevalue = -1;
    if ((micros() - _lastDecReadTime3) < _pauseLength) {
      changevalue = _fastIncrement * changevalue;
    }
    _lastDecReadTime3 = micros();
    counter3 = counter3 + changevalue;  // Update counter
    encval = 0;
  }
  if (counter3 > 127) {
    counter1 = 127;
  }
  if (counter3 < 0) {
    counter1 = 0;
  }
}
void read_encoder4() {
  // Encoder interrupt routine for both pins. Updates counter
  // if they are valid and have rotated a full indent

  static uint8_t old_AB = 3;                                                                  // Lookup table index
  static int8_t encval = 0;                                                                   // Encoder value
  static const int8_t enc_states[] = { 0, -1, 1, 0, 1, 0, 0, -1, -1, 0, 0, 1, 0, 1, -1, 0 };  // Lookup table

  old_AB <<= 2;  // Remember previous state

  if (digitalRead(ENC_G)) old_AB |= 0x02;  // Add current state of pin A
  if (digitalRead(ENC_H)) old_AB |= 0x01;  // Add current state of pin B

  encval += enc_states[(old_AB & 0x0f)];

  // Update counter if encoder has rotated a full indent, that is at least 4 steps
  if (encval > 3) {  // Four steps forward
    int changevalue = 1;
    if ((micros() - _lastIncReadTime4) < _pauseLength) {
      changevalue = _fastIncrement * changevalue;
    }
    _lastIncReadTime4 = micros();
    counter4 = counter4 + changevalue;  // Update counter
    encval = 0;
  } else if (encval < -3) {  // Four steps backward
    int changevalue = -1;
    if ((micros() - _lastDecReadTime4) < _pauseLength) {
      changevalue = _fastIncrement * changevalue;
    }
    _lastDecReadTime4 = micros();
    counter4 = counter4 + changevalue;  // Update counter
    encval = 0;
  }
  if (counter4 > 127) {
    counter1 = 127;
  }
  if (counter4 < 0) {
    counter1 = 0;
  }
}